'''                                                                
                                                       ║█║█║║║█║║               
                                                 █████║║║████║║║║║              
                                             ██║█║█║║║█║█║█║████║║              
                                        ║║███║║║█║█║█║█ ║║║║║║████              
                       ████║         █║║█║█║║║█║║███║████║║║║║║██║              
                       ███║█║██ ██║██║█████║║║█║║█║█║║██║║║║║║  ║               
                        ║██████║████║██║║║███║║║║██║║║██║║█║║║║║                
                         ║║█║██║║█║████║█║██║║█║║█║█║██║║█║██║                  
                      ██║█║║██║█║║║║█║█║║║║║║║█║║║║║║║║█║██║║                   
                   ║║║█║║║███║║█║██║║║║║║║║ ██║║║║║║║║║║║║║║                    
                █║██║║║║║█║█║║█║║██║║█║██║║║██║║║║║║ ║║║█║║                     
            ██║█ ██████║█║║██║║█████║║█║║║║║ ║║║║║║█ ║║║║║                      
          ║██║██████║████║║█║█║║║║║║║█║║║║║║█║║█║║║███║█                        
       ║║║█║██║║║║║║██║║█║║║║║██║║║ █║║█║║║║║║║║█║║█║███                        
     ║║█║█║║║║ ║║║║█║║║║█ ║║║║║║║║║║█║║║║║█ █║║█║║█║███║║                       
  █║║█║█║█║║██║║║███║║║ ║║║║║║║█ ██║║║║║║║█║█║║║█║██║║║║█║║                     
 ║║║║█║║║█║║║║█║║║║║ ║║█║║║║║║║║║║║█ ║║ █║███║║║██║║║║████║                     
 ║║║█║║║║║ ║║║║║║║║█║║║ ║║█║║ ║█║║║║║█║║║█║║║███║║█║║║█║║║║║                    
   █║║║█║║║█║║ ║║║║║║║║████║  ║║║ ║ ║ █ ║██ ║║║║█║██║║█║║║║║                    
         █ ║█║║║║    ║           ║█║║║██║║║║█║█║║██║║║║█║█║                     
                                 ║║║║║║█║║██║██║║║  ║ ║║█║║║                    
                                   █║█║║║║║║║█║███║║║║║█║██║║                   
                                   ║║███║█║║█║║║║║║ ║███ █║█║█                  
                                  ║║║█████║║║║ ║ █║║║║║█║█ ██║║                 
                                 ║║║║ ║█║║ ║║ ║║║║║█║█║║║║║█║║║║║               
                               ║║║█║║║║██  ║ █║  ████║██║ ║║ ║██║║              
                              █║║║║║║ █║  █║█║    ██║║║║█ ║║█║███║║             
                             ║║███║║║║║  ║ █║║      ██║█║ ║██║████║║            
                            ║║███║║║║    ██║║    ║ ║ ██║║ ║║║██║║██║            
                           ║║██║║██║█   ██║██    ██║║ ║█║ ║█║███║█║██           
                       ║  ███║█████║   ║██║█║██████║║█║ ║█║║║█║██║║║║║║         
                       █║██║║██████  ║║██║███████║    ║║║  ║║║█║██║██║███       
                      ║║║║║║║║║║║║     ║║█║║║║█║║ ║█║█║█║║║║║║║║║║║ ║████║
                   █║║█║███║║  ║║██║█║            ║      █████║║║║║║║ ║║║║║║█      

                      █████╗ ███████╗████████╗██████╗  ██████╗                                        
                      ██╔══██╗██╔════╝╚══██╔══╝██╔══██╗██╔═══██╗                                       
                      ███████║███████╗   ██║   ██████╔╝██║   ██║                                       
                      ██╔══██║╚════██║   ██║   ██╔══██╗██║   ██║                                       
                      ██║  ██║███████║   ██║   ██║  ██║╚██████╔╝                                       
                      ╚═╝  ╚═╝╚══════╝   ╚═╝   ╚═╝  ╚═╝ ╚═════╝                                        
                                                                                    
  ███████╗ ██████╗██╗  ██╗███████╗██████╗ ██╗   ██╗██╗     ██╗     ███████╗██████╗ 
  ██╔════╝██╔════╝██║  ██║██╔════╝██╔══██╗██║   ██║██║     ██║     ██╔════╝██╔══██╗
  ███████╗██║     ███████║█████╗  ██║  ██║██║   ██║██║     ██║     █████╗  ██████╔╝
  ╚════██║██║     ██╔══██║██╔══╝  ██║  ██║██║   ██║██║     ██║     ██╔══╝  ██╔══██╗
  ███████║╚██████╗██║  ██║███████╗██████╔╝╚██████╔╝███████╗███████╗███████╗██║  ██║
  ╚══════╝ ╚═════╝╚═╝  ╚═╝╚══════╝╚═════╝  ╚═════╝ ╚══════╝╚══════╝╚══════╝╚═╝  ╚═╝
'''

from .scheduller import *
from .schedule import *
from .core import *
from .config import *
from .editor import *
from .utilities import *
from .example import *

# Clean up old temporary files.
config().auto_clean() 

# Check if the AstroScheduller Core File is Valid
core().check_integrity()